{% extends '@Paa/Default/menu.html.twig' %}
{% block head %}
	<meta name="description" content="Planning">
{{ parent() }}

	<!-- IE10 viewport hack for Surface/desktop Windows 8 bug -->
	{#	MG Modification 20200703 asset_version remplacer mais le dossier est bien asset#}
{#    <link rel="stylesheet" type="text/css" href="{{asset_version('bootstrap/asset_versions/css/ie10-viewport-bug-workaround.css')}}">#}
    <link rel="stylesheet" type="text/css" href="{{asset_version('vendor/bootstrap/assets/css/ie10-viewport-bug-workaround.css')}}">
	
<!-- CSS ADAPTES POUR MULTISELECT -->	
	<style type="text/css"> 
		html, body {
			/*Pour que la page occupe tout l'espace vertical et qu'on puisse décider que le conteneur ppal va occuper tout ce qui est dispo*/
			padding : 0;
			margin : 0;
			height : 100%;
		}
		.LG-AvecContour{
		  height: 100%;
		  border: 1px solid black;
		  border-radius: 6px;
		}
	</style> 
<!-- CSS ADAPTES POUR MULTISELECT fin -->	

{%endblock%}

{% block titrePage %}
	{#<div class = "TitrePage">Planning</div>#}
	<!-- Menu horizontal-->
	<nav class="navbar navbar-top" style="margin-bottom: 0px;">
		<div class="container-fluid style">
			<!-- Brand and toggle get grouped for better mobile display -->
                        <a class="navbar-brand config-btn" href="#">
                            <span id="orientationIcon" class="menu-icon pull-right hidden-xs showopacity glyphicon material-icons">settings</span>
                        </a>
			<div class="navbar-header TitrePage">
{# MG 20191211 #}
                                
				{#<a class="navbar-brand" style="display: flex; padding: 0px; align-items: center;" title="Les planings avec PAA" href="http://www.paa-planning.net">#}
					{#<img id = "iconePAA" alt="Les plannings avec PAA" src="../images/paa.ico" style="width: 64px; padding: 7px 14px;">#}
					Planning
				{#</a>#}
			</div>

			<div class_DEAC_LG20200703CarMasqueSystematiquementAvecBootstrap4="collapse navbar-collapse" id="bs-example-navbar-collapse-1">
				<ul class="navbar-form navbar-right d-flex m-0 p-0">
                                    <!--
                                    MG 20191223 cbo2Dates est utilisé dans le menu
                                    <input id = "cbo2Dates"
                                            type="text" 
                                            data-role="cbo2Dates"
                                            data-speed="true"
{#						class="form-control cbo2Dates nav btn-default"
#}						class="btn cbo2Dates nav btn-default"
                                            style="width: 200px; display: inline; text-align: center; visibility: hidden;"
                                            style="width: 200px; display: inline; text-align: center; visibility: hidden;"
                                            />   -->                                
                                    <select id="cbcRessources"
                                            multiple="multiple"
                                            class="btn"
                                            style="height: 34px; text-align: left; width: 250px; visibility: hidden;"
                                            data-role="cbcRessource"
                                            data-speed="true"
                    						data-type-res="{{ psLstTypesRes }}"
                                            data-debut="{{ pdDateDébut|date("Y-m-d") }}"
                                            data-fin="{{ pdDateFin|date("Y-m-d") }}"
                                            >
                                            <option selected = "selected" value = "{{ psLstRes }}">Chargement en cours...</option>
                                    </select>
                                    <button id = "cmdCharge" type="submit" class="btn bg-white btn-default" style="height:25px;width:100px">Charger</button>
				</ul>
			</div><!-- /.navbar-collapse-->
                        
		</div><!-- /.container-fluid -->
	</nav>
	<!-- Fin de menu horizontal-->

{% endblock %}

{% block content %}
<div id="wrapper" style="height:100%;">
	
	<!-- Menu vertical gauche-->
	<nav id="sideBarConfig"
		data-role="planning_sideBarConfig"
		data-auto="true"
		>
	</nav>
	<!-- Fin de menu vertical gauche-->

	<!-- Container d'affichage du planning -->
	<div class="container col-lg-12" id = "mainContainer" style="height: 100%; position: absolute; left: 45px; width: calc(100% - 50px);">
		<div class="alert alert-warning" id="alerteErreurChargement" style="display: none;">
			<button type="button" class="close" data-dismiss="alert">x</button>
			<div id ="alerteErreurChargementContenu">
				<strong>Le chargement n'est pas possible! </strong>
				Vous n'avez pas sélectionné de ressource à afficher.
			</Div>
		</div>	
		<div class="row-lg-12" style="height: calc(100% - 140px);">
			<section id="Planning" class="LG-AvecContour border-0 shadow col-lg-12" style="Background-color:white; width: 100%; margin-left: -20px"></section>
		</div>
		<div class="row">
			<nav id="Erreurs" class="col-lg-12"></nav>
			<footer class=""></footer>
		</div>
	</div>
	<!-- Fin de container d'affichage du planning -->

</div>
{% endblock %}

{#Scripts qui doivent s'exécuter à la fin du body#}
{% block scriptsEnFinDeBody %}
{#{{ parent() }}#}
	{#Includes#}	
	<script type="text/javascript" src="{{asset_version('Limoog/Partages/src/include.js')}}"></script>
	<script type="text/javascript">
{# LG 20190405 deac
		// Il faut les réinclure car sinon l'alerte n'apparait pas quand pas de ressource sélectionnée ne s'affiche pas
		includeJS("{{asset_version('vendor/jQuery-3.3.1/jquery-3.3.1.min.js')}}") ;
		includeJS("{{asset_version('vendor/bootstrap/3.3.7/js/bootstrap.min.js')}}") ;
#}
		// IE10 viewport hack for Surface/desktop Windows 8 bug
		{#	MG Modification 20200703 asset_version remplacer mais le dossier est bien asset#}
{#		includeJS("{{asset_version('bootstrap/asset_versions/js/ie10-viewport-bug-workaround.js')}}") ;#}
		includeJS("{{asset_version('vendor/bootstrap/assets/js/ie10-viewport-bug-workaround.js')}}") ;

		// Grille du planning
		includeJS('{{asset_version('Limoog/Planning/cGrd_HTML-V2/src/includes_Grd.js')}}') ;

		// Bootstrap multiselect, http://davidstutz.de/bootstrap-multiselect/index.html#getting-started
		includeJS('{{asset_version('vendor/bootstrap/multiselect/js/bootstrap-multiselect.js')}}') ;
		includeCSS('{{asset_version('vendor/bootstrap/multiselect/css/bootstrap-multiselect.css')}}') ;
		
		// Bootstrap Date Range Picker, http://www.daterangepicker.com
		includeJS('{{asset_version('vendor/moment/moment.min.js')}}') ;
		includeJS('{{asset_version('vendor/bootstrap/daterangepicker/daterangepicker.js')}}') ;
		includeCSS('{{asset_version('vendor/bootstrap/daterangepicker/daterangepicker.css')}}') ;

		// planning_sideBarConfig
		includeJS('{{asset_version('Limoog/Planning/SideBarConfig/Planning_sideBarConfig_2.js')}}') ;
		includeCSS('{{asset_version('Limoog/Planning/SideBarConfig/Planning_sideBarConfig.css')}}') ;

		includeCSS('{{asset_version('Limoog/Partages/widgets/LGMultiselect/LGMultiselect.css')}}') ;
		includeJS('{{asset_version('Limoog/Partages/widgets/LGMultiselect/LGMultiselect.js')}}') ;
		includeJS('{{asset_version('Limoog/Paa/src/ressources.js')}}') ;
{# MG 20191223 cbo2Dates est utilisé dans le menu                 #}
{#		includeJS('{{asset_version('Limoog/Partages/widgets/cbo2Dates.js')}}') ;#}

		includeJS('{{asset_version('Limoog/Paa/src/popup_getIdActivite.js')}}');
                
                // speedWidget
                includeJS('{{asset_version('Limoog/Partages/widgets/speedWidget.js')}}');
	
// LG 20190530 ajouté pour getIdActivité début
includeJS('{{asset_version('Limoog/Symfony/entityForm.js')}}');
includeJS('{{asset_version('Limoog/Symfony/entityFormBoutons.js')}}');
includeJS('{{asset_version('Limoog/Symfony/entityFormGrille.js')}}');
includeJS('{{asset_version('Limoog/Partages/widgets/LGDataTable.js')}}');
	
	</script>

	{#Styles pour les icones de la sideBar#}
	<link href="https://fonts.googleapis.com/icon?family=Material+Icons" rel="stylesheet">

	
<script>
		//MG Modification 20200703
		//sinon initPlanning is not defined sans vhost
{#	$(document).ready(initialise);#}
	$(document).ready(function(){

		function html_recalcDimPlanning() {
			// Faire en sorte que le planning s'affiche jusqu'en bas de la page et pas plus
			// lonesomeday, http://stackoverflow.com/questions/11117216/css-width-calc100-100px-alternative-using-jquery
			var loSidebar = $("#sideBarConfig") ;
			var loMain = $("#mainContainer") ;
			var liTop = loMain.position().top ;
			loMain.css("height", "calc(100% + " + (liTop - 5) + "px)") ;
			loSidebar.css("height", "calc(100% - " + (liTop + 5) + "px)") ;
		}
		function html_afterResize(){
			if (window.oVue.currentWidth == $(window).width()
					&& window.oVue.currentHeight == $(window).height()) {
				// Le déplacement est terminé
				var event = jQuery.Event("onEndResize");
				$("body").trigger(event);
			}
		}

		// Redimensionnement du planning
		function html_redimPlanning() {
			html_recalcDimPlanning() ;
			if (window.oControleur.lPlanningChargé) {
				// Recharger le planning sans rafraichissement (redimension uniquement)
				chargePlanning(true) ;
			} else {
				initPlanning() ;
			}
		}

		function html_chargePlanning() {
			// Pour éviter que la demande de chargement se fasse alors que la cbc de ressources n'a pas encore envoyé ses modifs dans oConfig
			window.setTimeout(html_chargePlanning_Timeout, 10) ;
		}
		function html_chargePlanning_Timeout() {
			
			if (!window.oConfig.cLstRes) {
				// Pas de ressource sélectionnée
	//			alert("Vous n'avez pas sélectionné de ressource à afficher") ;
				$("#alerteErreurChargementContenu").html("<strong>Le chargement n'est pas possible! </strong><br>Vous n'avez pas sélectionné de ressource à afficher.");
				$("#alerteErreurChargement").alert();
				$("#alerteErreurChargement").fadeTo(2000, 500).slideUp(500, function(){
					$("#alerteErreurChargement").slideUp(500);
				});   

				return false ;
			}
			// Faire en sorte que le planning s'affiche jusqu'en bas de la page et pas plus
			html_recalcDimPlanning() ;
			// Lancer le chargement
			if (chargePlanning(window.oConfig)) {	// chargePlanning est dans cControleur_Grd.js
				 $("#cmdCharge").html("Rafraichir");
				 
				 window.oControleur.lPlanningChargé = true ;
			} else {
				$("#alerteErreurChargementContenu").html("<strong>Le chargement n'est pas possible! </strong><br>Une erreur est survenue au cours du chargement.");
				$("#alerteErreurChargement").alert();
				$("#alerteErreurChargement").fadeTo(2000, 500).slideUp(500, function(){
								$("#alerteErreurChargement").slideUp(500);
				});   
			}
			return true ;
		}

		function html_montreSideBarConfig() {
			$("#mainContainer")
				.css("position", "absolute")
				.css("left", "305px")
				.css("width", "calc(100% - 310px)");
			// Forcer le rafraichissement correct (sinon la place des scrollbars pose pb)
			html_afterResize() ;
			forceRefreshElement("#mainContainer") ;
		}
		function html_masqueSideBarConfig(evt, data) {
			$("#mainContainer")
				.css("position", "absolute")
				.css("left", "45px")
				.css("width", "calc(100% - 50px)") ;

	// alert("Masque") ;

			// Fusionner les nouveaux paramètres avec les actuels
			window.oConfig.extend(data) ;

			// Forcer le rafraichissement correct (sinon la place des scrollbars pose pb)
			html_afterResize() ;
			forceRefreshElement("#mainContainer") ;
		}

		function initialise() {
			$("#alerteErreurChargement").hide();

			// Faire en sorte que le planning s'affiche jusqu'en bas de la page et pas plus
			html_recalcDimPlanning() ;

			// Forcer le mode webBrowser, car en le faisant dans les événements du webBrowser VFP c'est parfois trop tard
			window.lWebBrowserVFPControl = false ;

			// Charger le planning
			initPlanning() ;	// initPlanning est dans cControleur_Grd.js
			window.oVue = {} ;
			window.oControleur = {} ;
	// , cTypeHoraire: "I"
			window.oConfig = {
				dDebut: moment().isoWeekday(1).format("YYYY/MM/DD")
				, dFin: moment().isoWeekday(7).format("YYYY/MM/DD")
				, cLstRes: '{{ psLstRes }}'
				, cLstJoursAffichage: '<Auto>'
				, cTypeAffichageJours: 'N'
				, cOrientation: "V"
				, vertical: true
				, cTypeCouleur: "1"
				, nDureeDftSeance: 1
				, cTypeArrondi: "2"
				, bDisposeChronologiquement: true
				, bSepareRessources: true
				, bDecoupeSeances: false
				, bAfficheAnomaliesToutes: false
				, bAfficheAnomaliesSéanceActive: false
				, bAfficheAnomaliesPlacement: false
				, iModeExecution: 4
				// Fusionner les propriétés avec celles de l'objet fourni
				, extend: function(poConfig) {
					if (poConfig && poConfig.cOrientation) {
						// On a fourni une configuration à recharger
						jQuery.extend(window.oConfig, poConfig) ;
						window.oConfig.vertical = (window.oConfig.cOrientation === "V") ;
					}
				}			} ;

			// Sur resize du ViewPort
			$(window).on('resize orientationChange', function(event) {
				window.oVue.currentWidth = $(window).width();
				window.oVue.currentHeight = $(window).height();
				setTimeout(html_afterResize, 500) ;
			});
			// Sur fin du resize (au bout de 500ms sans dimensionnement)
			$('body').bind('onEndResize', function(e) { 
				html_redimPlanning() ;
			});

			$('#cmdCharge').on('click', html_chargePlanning) ;
			$('body').bind('onClicSurMasquePlanning', html_chargePlanning); 

			$("#sideBarConfig").bind('onChangeConfig', function() {
				window.oControleur.onChangeConfig() ;
			});
			$("#sideBarConfig").bind('onValide', function(evt, data) {
				// Fusionner les nouveaux paramètres avec les actuels
				window.oConfig.extend(data) ;
				// Charger le planning
				html_chargePlanning(data) ;
			});
			$("#sideBarConfig").bind('onMontre', html_montreSideBarConfig);
			$("#sideBarConfig").bind('onMasque', html_masqueSideBarConfig);

			// Sur changement des dates de début/fin
			function cbo2Dates_afterChange(ev, picker){
				if (window.oConfig.dDebut !== picker.startDate.format('YYYY-MM-DD')
						|| window.oConfig.dFin !== picker.endDate.format('YYYY-MM-DD')) {
					// Au moins une date a changé
					window.oConfig.dDebut = picker.startDate.format('YYYY-MM-DD') ;
					window.oConfig.dFin = picker.endDate.format('YYYY-MM-DD') ;

					// Recharger la liste des ressources
					var laVal = $("[data-role=cbcRessource]").val() ;
					var loCbc = $("[data-role=cbcRessource]")[0] ;
					fillCbcRessource(loCbc, {});	// Vider la liste
					loCbc.dataset.debut = window.oConfig.dDebut ;
					loCbc.dataset.fin = window.oConfig.dFin ;
					ajax_FillcbcRessources(loCbc, laVal) ;	// Reremplir la liste

					// Avertir le controleur de planning du changement
					window.oControleur.onChangeConfig() ;
				}
			}
			$('#cbo2Dates').on('apply.daterangepicker', function(ev, picker) {
				return cbo2Dates_afterChange(ev, picker) ;
			});
			$('#cbo2Dates').on('outsideClick.daterangepicker', function(ev, picker) {
				return cbo2Dates_afterChange(ev, picker) ;
			});

			// Sur changement de l liste de ressource sélectionnée
			$('body').bind('onValideChangecbcRessource', function(e) {
				if (e.source === "cbcRessources") {
					// Avertir du changement
					if (e.aLstRes) window.oConfig.cLstRes = e.aLstRes.join(',') ;
					else window.oConfig.cLstRes = '' ;
					window.oControleur.onChangeConfig() ;
				}
			});

			window.oControleur.onChangeConfig = function() {
				$("#cmdCharge").html("Charger") ;
				window.oPlanning.oControleur.masqueGrille() ;
				window.oControleur.lPlanningChargé = false ;
			};
		}
		initialise();
	});
	
</script>
{% endblock %}
